function Y(e) {
  if (e.length !== 7 && e.length !== 9)
    throw new Error("Invalid hex color");
  const o = parseInt(e.slice(1, 3), 16) / 255, i = parseInt(e.slice(3, 5), 16) / 255, l = parseInt(e.slice(5, 7), 16) / 255;
  let r = { r: o, g: i, b: l };
  if (e.length === 9) {
    const t = parseInt(e.slice(7, 9), 16) / 255;
    r = { r: o, g: i, b: l, a: t };
  }
  return r;
}
function A(e) {
  const o = e.match(/\d+\.?\d*/g);
  if (!o || o.length < 3)
    return { r: 0, g: 0, b: 0, a: 0 };
  const i = parseInt(o[0]) / 255, l = parseInt(o[1]) / 255, r = parseInt(o[2]) / 255, t = o.length === 4 ? parseFloat(o[3]) : 1;
  return { r: i, g: l, b: r, a: t };
}
function q(e) {
  const o = {
    "to top": 270,
    // correct with translation - a 270-degree angle points upward in a standard system, which maps to top in Figma.
    "to right": 0,
    // correct - 0 degrees points to the right.
    "to bottom": 90,
    // correct - 90 degrees points downward.
    "to left": 180,
    // correct with translation - 180 degrees points to the left.
    "to top right": 315,
    //  correct with 0.5 translation
    "to right top": 315,
    // ??? idk how to do this in css
    "to bottom right": 45,
    //  correct with 0.5 translation
    "to right bottom": 45,
    // ??? idk how to do this in css
    "to bottom left": 135,
    // correct with -0.5 translation
    "to left bottom": 135,
    // ??? idk how to do this in css
    "to top left": 225,
    // correct with 1.5 translation
    "to left top": 225
    // ??? idk how to do this in css
  }, i = e.toLowerCase().replace(/\s+/g, " ").trim();
  return o[i] === void 0 ? o["to bottom"] : o[i];
}
function J(e) {
  if (typeof e != "number" || isNaN(e))
    return console.error("Invalid input: angle must be a valid number."), [
      [1, 0, 0],
      [0, 1, 0]
    ];
  const o = e * Math.PI / 180, i = Math.cos(o), l = Math.sin(o), r = 0;
  let t = 0;
  switch (e) {
    case 270:
      t = 1;
      break;
    case 180:
      t = 1;
      break;
    case 315:
      t = 0.5;
      break;
    case 45:
      t = 0.5;
      break;
    case 135:
      t = -0.5;
      break;
    case 225:
      t = 1.5;
      break;
  }
  return [
    [i, l, -l * t],
    // Apply translations
    [-l, i, i * r]
    // Adjusting coordinates
  ];
}
function K(e) {
  const i = e.substring(
    e.indexOf("(") + 1,
    e.lastIndexOf(")")
  ).split(
    /,(?![^(]*\))(?![^"']*["'](?:[^"']*["'][^"']*["'])*[^"']*$)/
  ), l = i[0].trim(), r = q(l), t = J(r);
  let b;
  return i.length > 2 ? b = i.slice(1).map((n) => n.trim()) : b = i.map((n) => n.trim()), {
    gradientStops: b.map((n, c) => ({
      color: { ...A(n), a: 1 },
      position: c / (b.length - 1)
      // this can't be greater than 1, because it's a percentage. so convert index to percentage
    })),
    gradientTransform: t
  };
}
function H(e, o) {
  if (e.startsWith("#")) {
    const i = Y(e), l = i.a ? i.a : 1;
    return delete i.a, {
      blendMode: "NORMAL",
      type: "SOLID",
      color: i,
      boundVariables: {},
      opacity: o !== void 0 ? o : l,
      visible: !0
    };
  } else if (e.startsWith("rgb")) {
    const i = A(e), l = i.a !== void 0 ? i.a : 1;
    return delete i.a, {
      blendMode: "NORMAL",
      type: "SOLID",
      color: i,
      boundVariables: {},
      opacity: o !== void 0 ? o : l,
      visible: !0
    };
  } else if (e.includes("gradient")) {
    const i = K(e);
    return {
      blendMode: "NORMAL",
      type: "GRADIENT_LINEAR",
      gradientStops: i.gradientStops,
      gradientTransform: i.gradientTransform,
      opacity: o !== void 0 ? o : 1,
      visible: !0
    };
  } else {
    if (e === "transparent")
      return {
        blendMode: "NORMAL",
        type: "SOLID",
        color: { r: 1, g: 1, b: 1 },
        boundVariables: {},
        opacity: 0,
        visible: !0
      };
    if (e.startsWith("url"))
      return {
        blendMode: "NORMAL",
        type: "IMAGE",
        imageUrl: e,
        opacity: o !== void 0 ? o : 1,
        visible: !0
      };
  }
}
function O(e) {
  return e === 'ui-monospace, SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace' ? "Ubuntu Mono" : e === '"Open Sans"' ? "Open Sans" : e.replace(/"/g, "");
}
function v(e, o) {
  return e === "100" ? "Thin" : e === "200" ? "Extra Light" : e === "300" ? "Light" : e === "400" ? "Regular" : e === "500" && o && O(o) === "Open Sans" ? "SemiBold" : e === "500" ? "Medium" : e === "600" && o && O(o) === "Open Sans" ? "SemiBold" : e === "600" ? "Semi Bold" : e === "700" ? "Bold" : e === "800" ? "Extra Bold" : e === "900" ? "Black" : e;
}
function f(e) {
  const { a: o, ...i } = A(e);
  return {
    blendMode: "NORMAL",
    type: "SOLID",
    color: i,
    boundVariables: {},
    opacity: o !== void 0 ? o : 1,
    visible: !0
  };
}
function s(e) {
  if (e === "normal")
    return 1.2;
  if (e.endsWith("px"))
    return parseInt(e.slice(0, -2));
  if (e === "auto")
    return;
  if (e.endsWith("%"))
    return 1e3;
  if (e.startsWith("clamp"))
    return;
  throw new Error(`Unhandled value case: ${e}`);
}
function w(e) {
  const o = e.getBoundingClientRect();
  return {
    left: o.left + window.scrollX,
    top: o.top + window.scrollY
  };
}
function N(e, o, i) {
  const l = e.getAttribute("style");
  if (l && l.includes(o)) {
    const n = l.match(
      new RegExp(`${o}\\s*:\\s*([^;]+);`)
    );
    if (n && n[1])
      return n[1].trim();
  }
  let r = null, t = 0;
  const b = (n) => {
    let c = 0;
    const d = (n.match(/#/g) || []).length, R = (n.match(/\./g) || []).length + (n.match(/\[/g) || []).length + (n.match(/:/g) || []).length, g = n.replace(/[#.:[\] +>~]/g, "").length;
    return c += d * 100, c += R * 10, c += g, c;
  }, m = i ?? document.styleSheets;
  for (let n = m.length - 1; n >= 0; n--) {
    const c = m[n];
    try {
      const d = c.rules || c.cssRules;
      for (let R = d.length - 1; R >= 0; R--) {
        const g = d[R];
        if (e.matches(g.selectorText)) {
          const h = b(g.selectorText);
          if (h >= t) {
            const S = g.style.getPropertyValue(o);
            S && (t = h, r = S.trim());
          }
        }
      }
    } catch (d) {
      console.error("Cannot read CSS rule: ", d);
    }
  }
  return r;
}
function Q(e) {
  const o = /rgba?\(\d+, \d+, \d+(, \d(\.\d+)?)?\) -?\d+px -?\d+px -?\d+px -?\d+px/g, i = e.match(o);
  if (!i)
    throw new Error("No valid shadows found.");
  return i.map((l) => {
    const r = l.match(
      /(rgba?\(\d+, \d+, \d+(, \d(\.\d+)?)?\))|(-?\d+px)/g
    );
    if (!r || r.length !== 5)
      throw new Error("Shadow parsing error.");
    return {
      colorRgba: A(r[0]),
      offsetX: s(r[1]),
      offsetY: s(r[2]),
      radius: s(r[3]),
      spread: s(r[4])
    };
  });
}
function tt(e) {
  return e === "start" ? "LEFT" : e === "end" ? "RIGHT" : e.toUpperCase();
}
function et(e) {
  const o = (i) => {
    if (i && (i.metadata && delete i.metadata, i.children))
      for (const l of i.children)
        o(l);
  };
  o(e);
}
function ot(e, o) {
  const i = Z(e, void 0, o);
  return et(i), i;
}
const Z = (e, o, i) => {
  var l;
  if (e.nodeType === 1) {
    const r = e, t = getComputedStyle(r);
    if (t.display === "none" || t.visibility === "hidden")
      return;
    const { left: b, top: m } = w(r), n = r.tagName.toUpperCase();
    let c = {
      left: 0,
      top: 0
    };
    if (o && (c = w(o)), n === "OPTION")
      return;
    if (n === "SVG") {
      const { left: a, top: p } = w(r);
      let T = {
        left: 0,
        top: 0
      };
      o && (T = w(o));
      const L = r.getBoundingClientRect().width, F = r.getBoundingClientRect().height, $ = s(t.strokeWidth);
      return {
        type: "SVG",
        svg: r.outerHTML,
        x: a - T.left,
        y: p - T.top,
        width: L,
        height: F,
        strokeWeight: $,
        strokes: [f(t.color)],
        metadata: {
          display: t.display,
          node: e
        }
      };
    }
    let d = "Container";
    n === "INPUT" ? d = "Input" : n === "BUTTON" ? d = "Button" : n === "H1" || n === "H2" || n === "H3" || n === "H4" || n === "H5" || n === "H6" ? d = "Heading" : n === "P" ? d = "Paragraph" : n === "LABEL" ? d = "Label" : n === "SECTION" ? d = "Section" : n === "FORM" ? d = "Form" : n === "IMG" ? d = "Image" : n === "SPAN" ? d = "Span" : n === "SELECT" && (d = "Select");
    const R = b - c.left, g = m - c.top, h = r.getBoundingClientRect().width, S = r.getBoundingClientRect().height, u = [];
    for (const a of r.childNodes) {
      const p = Z(a, r);
      Array.isArray(p) ? u.push(...p) : u.push(p);
    }
    let E = {};
    if (n === "INPUT") {
      const a = r.getAttribute("type");
      if (a === "radio") {
        const T = r.checked, L = "rgb(0,117,255)";
        return {
          name: "Radio Input",
          type: "FRAME",
          x: R,
          y: g,
          width: h,
          height: S,
          topLeftRadius: 100,
          topRightRadius: 100,
          bottomLeftRadius: 100,
          bottomRightRadius: 100,
          strokes: [
            f(
              T ? L : "rgb(118,118,118)"
            )
          ],
          strokeTopWeight: 1,
          strokeBottomWeight: 1,
          strokeLeftWeight: 1,
          strokeRightWeight: 1,
          layoutMode: "HORIZONTAL",
          layoutSizingHorizontal: "FIXED",
          layoutSizingVertical: "FIXED",
          counterAxisAlignItems: "CENTER",
          primaryAxisAlignItems: "CENTER",
          padding: {
            right: 2,
            left: 2,
            top: 2,
            bottom: 2
          },
          ...T && {
            children: [
              {
                type: "FRAME",
                name: "Radio Checked",
                layoutSizingHorizontal: "FILL",
                layoutSizingVertical: "FILL",
                backgroundFill: f(L),
                topLeftRadius: 100,
                topRightRadius: 100,
                bottomLeftRadius: 100,
                bottomRightRadius: 100
              }
            ]
          },
          metadata: {
            display: "block",
            node: e
          }
        };
      } else if (a === "checkbox") {
        const T = e.checked, L = "rgb(0,117,255)";
        return {
          name: "Radio Input",
          type: "FRAME",
          x: R,
          y: g,
          width: h,
          height: S,
          topLeftRadius: 2,
          topRightRadius: 2,
          bottomLeftRadius: 2,
          bottomRightRadius: 2,
          strokes: [
            f(
              T ? L : "rgb(118,118,118)"
            )
          ],
          strokeTopWeight: 1,
          strokeBottomWeight: 1,
          strokeLeftWeight: 1,
          strokeRightWeight: 1,
          layoutMode: "HORIZONTAL",
          layoutSizingHorizontal: "FIXED",
          layoutSizingVertical: "FIXED",
          counterAxisAlignItems: "CENTER",
          primaryAxisAlignItems: "CENTER",
          padding: {
            right: 2,
            left: 2,
            top: 2,
            bottom: 2
          },
          backgroundFill: f(
            T ? L : "rgb(255,255,255)"
          ),
          ...T && {
            children: [
              {
                type: "SVG",
                svg: '<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"><path d="M20 6 9 17l-5-5"></path></svg>',
                x: 1,
                y: 1,
                width: h - 2,
                height: S - 2,
                strokeWeight: 1,
                strokes: [f("rgb(255,255,255)")]
              }
            ]
          },
          metadata: {
            display: "block",
            node: e
          }
        };
      }
      const p = e;
      E = {
        layoutMode: "HORIZONTAL",
        layoutSizingHorizontal: "FIXED",
        counterAxisAlignItems: "CENTER",
        primaryAxisAlignItems: "SPACE_BETWEEN"
      }, p.value ? u.push({
        name: "Input Value",
        type: "TEXT",
        characters: p.value || "",
        fontSize: s(t.fontSize),
        lineHeight: {
          unit: "PIXELS",
          value: s(t.lineHeight)
        },
        color: f(t.color),
        fontWeight: v(
          t.fontWeight,
          t.fontFamily
        )
      }) : r.getAttribute("placeholder") ? u.push({
        name: "Input Placeholder",
        type: "TEXT",
        characters: r.getAttribute("placeholder"),
        fontSize: s(t.fontSize),
        fontWeight: v(
          t.fontWeight,
          t.fontFamily
        ),
        lineHeight: {
          unit: "PIXELS",
          value: s(t.lineHeight)
        },
        color: {
          blendMode: "NORMAL",
          type: "SOLID",
          color: {
            r: 0.8,
            g: 0.8,
            b: 0.8
          },
          boundVariables: {},
          opacity: 1,
          visible: !0
        }
      }) : a === "date" && u.push({
        name: "Date Placeholder",
        type: "TEXT",
        characters: "mm/dd/yyyy",
        fontSize: s(t.fontSize),
        fontWeight: v(
          t.fontWeight,
          t.fontFamily
        ),
        lineHeight: {
          unit: "PIXELS",
          value: s(t.lineHeight)
        },
        color: f(t.color)
      }), a === "date" && u.push({
        type: "SVG",
        svg: `<svg xmlns="http://www.w3.org/2000/svg" width="141" height="146">
<path d="M13.3,126.4V37.4c0-2.4,.9-4.5,2.6-6.3c1.7-1.8,3.8-2.6
6.2-2.6h8.8v-6.7c0-3.1,1.1-5.7,3.2-7.9c2.2-2.2,4.7-3.3,7.8-3.3h4.4c3,0
5.6,1.1,7.8,3.3c2.2,2.2,3.2,4.8,3.2,7.9v6.7h26.4v-6.7c0-3.1,1.1-5.7
3.2-7.9c2.2-2.2,4.7-3.3,7.8-3.3h4.4c3,0,5.6,1.1,7.8,3.3c2.2,2.2,3.2
4.8,3.2,7.9v6.7h8.8c2.4,0,4.4,.9,6.2,2.6c1.7,1.8,2.6,3.8,2.6,6.3v88.9c0
2.4-.9,4.5-2.6,6.3c-1.7,1.8-3.8,2.6-6.2,2.6H22.1c-2.4,0-4.4-.9-6.2-2.6C14.2,130.8
13.3,128.8,13.3,126.4z M22.1,126.4h96.8V55.2H22.1V126.4z M39.7,41.9c0,.6,.2,1.2
.6,1.6c.4,.4,.9,.6,1.6,.6h4.4c.6,0,1.2-.2,1.6-.6c.4-.4
.6-.9,.6-1.6v-20c0-.6-.2-1.2-.6-1.6c-.4-.4-.9-.6-1.6-.6h-4.4c-.6,0-1.2,.2-1.6
.6c-.4,.4-.6,1-.6,1.6V41.9z
M92.5,41.9c0,.6,.2,1.2,.6,1.6c.4,.4,.9,.6
1.6,.6h4.4c.6,0,1.2-.2,1.6-.6c.4-.4
.6-.9,.6-1.6v-20c0-.6-.2-1.2-.6-1.6c-.4-.4-.9-.6-1.6-.6h-4.4c-.6
0-1.2,.2-1.6,.6c-.4,.4-.6,1-.6,1.6V41.9z"/>
</svg>`,
        width: s(t.fontSize),
        height: s(t.fontSize),
        strokeWeight: 1,
        strokes: [f(t.color)]
      }), u.length === 1 && (E.primaryAxisAlignItems = "MIN");
    }
    if (n === "TEXTAREA") {
      const a = e;
      E = {
        layoutMode: "HORIZONTAL",
        layoutSizingHorizontal: "FIXED"
      }, a.value ? u.push({
        name: "Textarea Value",
        type: "TEXT",
        characters: a.value || "",
        fontSize: s(t.fontSize),
        lineHeight: {
          unit: "PIXELS",
          value: s(t.lineHeight)
        },
        color: f(t.color),
        fontWeight: v(
          t.fontWeight,
          t.fontFamily
        )
      }) : a.placeholder && u.push({
        name: "Textarea Placeholder",
        type: "TEXT",
        characters: a.placeholder,
        fontSize: s(t.fontSize),
        fontWeight: v(
          t.fontWeight,
          t.fontFamily
        ),
        lineHeight: {
          unit: "PIXELS",
          value: s(t.lineHeight)
        },
        color: {
          blendMode: "NORMAL",
          type: "SOLID",
          color: {
            r: 0.8,
            g: 0.8,
            b: 0.8
          },
          boundVariables: {},
          opacity: 1,
          visible: !0
        }
      });
    }
    if (n === "SELECT") {
      const a = e;
      E = {
        layoutMode: "HORIZONTAL",
        layoutSizingHorizontal: "FIXED",
        counterAxisAlignItems: "CENTER",
        primaryAxisAlignItems: "SPACE_BETWEEN"
      };
      const p = a.selectedIndex >= 0 ? a.options[a.selectedIndex].text : "";
      u.push({
        name: "Select Value",
        type: "TEXT",
        characters: p,
        fontSize: s(t.fontSize),
        lineHeight: {
          unit: "PIXELS",
          value: s(t.lineHeight)
        },
        color: f(t.color),
        fontWeight: v(
          t.fontWeight,
          t.fontFamily
        )
      }), t.appearance !== "none" && u.push({
        type: "SVG",
        svg: `<svg width="800px" height="800px" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
<path fill-rule="evenodd" clip-rule="evenodd" d="M16.5303 8.96967C16.8232 9.26256 16.8232 9.73744 16.5303 10.0303L12.5303 14.0303C12.2374 14.3232 11.7626 14.3232 11.4697 14.0303L7.46967 10.0303C7.17678 9.73744 7.17678 9.26256 7.46967 8.96967C7.76256 8.67678 8.23744 8.67678 8.53033 8.96967L12 12.4393L15.4697 8.96967C15.7626 8.67678 16.2374 8.67678 16.5303 8.96967Z" fill="#000000"/>
</svg>`,
        width: s(t.fontSize),
        height: s(t.fontSize),
        strokeWeight: 1,
        strokes: [f(t.color)]
      });
    }
    const y = N(
      r,
      "background-color",
      i
    ), I = N(
      r,
      "background-image",
      i
    ), _ = N(
      r,
      "background",
      i
    ), B = N(
      r,
      "opacity",
      i
    ), M = B !== null ? Number(B) : void 0;
    let x, k = null;
    if (y)
      x = H(
        t.backgroundColor,
        M
      );
    else if (I)
      t.backgroundImage.startsWith("url(") ? k = t.backgroundImage.slice(5, -2) : x = H(
        t.backgroundImage,
        M
      );
    else if (_)
      x = H(
        t.background,
        M
      );
    else if (!o || n === "INPUT") {
      const a = A(t.backgroundColor);
      let p = { r: 1, g: 1, b: 1 };
      a.a && a.a !== 0 && (p = { ...a, a: void 0 }), x = {
        blendMode: "NORMAL",
        type: "SOLID",
        color: p,
        boundVariables: {},
        opacity: Number(t.opacity),
        visible: !0
      };
    } else
      n === "IMG" && (k = r.getAttribute("src"), k || (x = {
        blendMode: "NORMAL",
        type: "SOLID",
        color: {
          r: 0.2,
          g: 0.2,
          b: 0.2
        },
        boundVariables: {},
        opacity: 1,
        visible: !0
      }));
    let C = 0, z = {};
    const V = t.borderWidth !== "0px" || t.borderTopWidth !== "0px" || t.borderBottomWidth !== "0px" || t.borderLeftWidth !== "0px" || t.borderRightWidth !== "0px";
    !V && t.outlineWidth !== "0px" && (z = {
      strokes: [f(t.outlineColor)],
      strokeAlign: "OUTSIDE",
      strokeTopWeight: s(t.outlineWidth),
      strokeBottomWeight: s(t.outlineWidth),
      strokeLeftWeight: s(t.outlineWidth),
      strokeRightWeight: s(t.outlineWidth),
      dashPattern: t.outlineStyle === "dashed" ? [2, 2] : void 0
    }), V && (z = {
      strokeAlign: "INSIDE",
      strokes: [f(t.borderColor)],
      strokeTopWeight: s(t.borderTopWidth),
      strokeBottomWeight: s(t.borderBottomWidth),
      strokeLeftWeight: s(t.borderLeftWidth),
      strokeRightWeight: s(t.borderRightWidth),
      dashPattern: t.borderStyle === "dashed" ? [2, 2] : void 0
    }, C += s(t.borderWidth) ?? 0);
    const W = {};
    t.borderTopLeftRadius !== "0x" && (W.topLeftRadius = s(
      t.borderTopLeftRadius
    )), t.borderTopRightRadius !== "0x" && (W.topRightRadius = s(
      t.borderTopRightRadius
    )), t.borderBottomLeftRadius !== "0x" && (W.bottomLeftRadius = s(
      t.borderBottomLeftRadius
    )), t.borderBottomRightRadius !== "0x" && (W.bottomRightRadius = s(
      t.borderBottomRightRadius
    ));
    let P = {};
    if (t.boxShadow && t.boxShadow !== "none")
      try {
        P = {
          dropShadows: Q(t.boxShadow)
        };
      } catch {
        console.warn(`Error parsing drop shadow: ${t.boxShadow}`);
      }
    const X = [];
    if (t.filter && t.filter !== "none" && t.filter.includes("blur(")) {
      const a = t.filter.match(/blur\(([^)]+)\)/);
      a && X.push({
        visible: !0,
        radius: parseInt(a[1]),
        type: "LAYER_BLUR"
      });
    }
    const D = s(t.paddingRight), U = s(t.paddingLeft), G = s(t.paddingTop), j = s(t.paddingBottom);
    return {
      name: d,
      type: "FRAME",
      x: R,
      y: g,
      width: h,
      height: S,
      clipsContent: t.overflow === "hidden",
      children: u,
      backgroundFill: x,
      imageUrl: k,
      padding: {
        right: D ? D + C : void 0,
        left: U ? U + C : void 0,
        top: G ? G + C : void 0,
        bottom: j ? j + C : void 0
      },
      effects: X,
      ...z,
      ...W,
      ...P,
      ...E,
      metadata: {
        display: t.display,
        node: e
      }
    };
  } else if (e.nodeType === 3) {
    if (!o)
      throw new Error("no parent found to text node");
    if (!e.parentElement)
      return;
    const r = document.createRange();
    r.selectNodeContents(e);
    const t = o.getBoundingClientRect(), b = r.getBoundingClientRect(), m = [];
    let n = 0, c = "";
    const R = (e.textContent ?? "").split(/(\s+)/);
    let g = b;
    R.forEach((y) => {
      r.setStart(e, n), r.setEnd(e, n + c.length + y.length);
      const I = r.getClientRects();
      g = I[0], I.length > 1 ? (m.push({
        x: I[0].left - t.left,
        y: I[0].top - t.top,
        width: I[0].width,
        height: I[0].height,
        characters: c
      }), n = n + c.length, c = y, g = I[1]) : c += y;
    }), g && m.push({
      x: g.left - t.left,
      y: g.top - t.top,
      width: g.width,
      height: g.height,
      characters: c
    });
    const h = getComputedStyle(o);
    let S;
    h.color !== "rgba(0, 0, 0, 0)" && (S = f(h.color));
    const u = s(h.fontSize), E = u ? u * 0.85 : void 0;
    return e.parentElement.tagName.toUpperCase() === "LI" && m.push({
      x: -20,
      y: 0,
      width: E ?? 16,
      height: ((l = m[0]) == null ? void 0 : l.height) ?? 16,
      characters: "•"
    }), m.map((y) => ({
      type: "TEXT",
      x: y.x,
      y: y.y,
      width: y.width,
      height: y.height,
      characters: y.characters,
      fontSize: E,
      color: S,
      textAutoResize: "HEIGHT",
      textAlignVertical: "CENTER",
      textAlignHorizontal: tt(h.textAlign),
      lineHeight: {
        unit: "PIXELS",
        value: s(h.lineHeight)
      },
      fontWeight: v(
        h.fontWeight,
        h.fontFamily
      ),
      metadata: {
        display: "inline",
        node: e
      },
      fontFamily: O(h.fontFamily)
    }));
  }
};
export {
  ot as htmlToFigma
};
